## This file is a part of PyGG: PyGTK and Glade
## (C) 2005 Franck Pommereau <pommereau@univ-paris12.fr>
##
## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
##
## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## Lesser General Public License for more details.
##
## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# a simple hello world example: when a button is pressed, an entry
# show the text 'Hello World!' and is cleared after 1 second. A
# progress bar pulses every time the button is clicked.

import gobject
import pygg

# tell PyGG where it will fin the Glade files
pygg.sources.add(".")

class HelloWorld (pygg.AppWindow) :
    "An AppWindow is intended to be the main window of a program"
    def on_button_hello_clicked (self, widget) :
        "Callback for button click"
        # the attribute 'entry' and 'progressbar' refer to the so
        # called widgets in the Glade file
        self.entry.set_text("Hello world!")
        self.progressbar.pulse()
        if hasattr(self, "_id") :
            gobject.source_remove(self._id)
        self._id = gobject.timeout_add(1000, self._clear)
    def on_window_deleted (self, widget, event) :
        "Callback when the window is deleted (closed)"
        # the method 'quit' hides the AppWindow and terminates the GTK
        # main loop
        self.quit()
    def _clear (self) :
        self.entry.set_text("")

# the methode 'run' shows the AppWindow and starts the GTK main loop
HelloWorld().run()
